;
;This is public domain.
;

;typedef struct audio_buf_info {
;                        int fragments;  /* # of available fragments (partially usend ones not counted) */
;                        int fragstotal; /* Total # of fragments allocated */
;                        int fragsize;   /* Size of a fragment in bytes */
;
;                        int bytes;      /* Available space in bytes (includes partially used fragments) */
;                        /* Note! 'bytes' could be more than fragments*fragsize */
;                } audio_buf_info;

;a note is 8 bits :
;xxx yyyyy
;xxx = duration (0 = cc, 1 = c, 3 = n, 7 = b)
;yyyyy = highing of the note ("hauteur"). Makes 32 notes, almost 3 octaves, much enough.
;        0 means silence
;a value of -1 means a loop, thus the next byte gives the nb of bytes to go back, and the next the nb of times do the loop
;(the current pos we go back from is the pos of the byte giving the nb of bytes to go back) (what a nice sentence !)
;the first instrument is a bass, the second is higher.

db 30		;volume of instrument
dw 55		;base note
melodie_1:
%define X 3
	db 7*32
	db -1, 2, 22

	db 3*32+10+X, 7*32+17+X
	db 3*32+10+X, 7*32+17+X
	db 3*32+17+X, 3*32+15+X, 3*32+13+X
	db 3*32+15+X, 3*32+17+X, 3*32+10+X
	db 3*32+10+X, 7*32+17+X
	db 3*32+10+X, 7*32+17+X
	db 3*32+17+X, 3*32+15+X, 3*32+13+X
	db 3*32+12+X, 7*32+10+X
;	db -1, 20, 2

	db 3*32+10+X, 7*32+12+X
	db 3*32+12+X, 7*32+12+X
	db 3*32+15+X, 7*32+13+X
	db 3*32+10+X, 3*32+12+X, 3*32+1
	db 3*32+10+X, 7*32+12+X
	db 3*32+12+X, 7*32+12+X
	db 3*32+15+X, 3*32+13+X, 3*32+12+X
	db 3*32+13+X, 7*32+10+X
;	db -1, 19, 2

;	db -1, 20+19+5, 2

	db 7*32
	db -1, 2, 128
db 45
dw 440
melodie_2:
	db 7*32
	db -1, 2, 22

;	db 1*32
;	db -1, 2, 48*4

	db 3*32+17+X, 3*32+14+X
	db 1*32+10+X, 1*32+12+X, 1*32+17+X, 1*32+10+X, 3*32+14+X
	db 1*32+17+X, 1*32+15+X, 1*32+14+X, 1*32+15+X, 3*32+12+X
	db 1*32+10+X, 1*32+12+X, 1*32+14+X, 1*32+15+X, 7*32+14+X

	db 3*32+17+X, 3*32+14+X
	db 1*32+10+X, 1*32+12+X, 1*32+17+X, 1*32+10+X, 3*32+14+X
	db 1*32+17+X, 1*32+15+X, 1*32+14+X, 1*32+15+X, 3*32+12+X
	db 1*32+15+X, 1*32+14+X, 1*32+12+X, 1*32+14+X, 7*32+10+X
;	db -1, 35, 2

	db 3*32+17+X, 3*32+13+X
	db 1*32+12+X, 1*32+10+X, 1*32+13+X, 1*32+12+X, 3*32+13+X
	db 1*32+15+X, 1*32+13+X, 1*32+12+X, 1*32+13+X, 3*32+15+X ;3*32+15+X
	db 1*32+17+X, 1*32+15+X, 1*32+13+X, 1*32+15+X, 7*32+17+X

	db 3*32+17+X, 3*32+13+X
	db 1*32+12+X, 1*32+10+X, 1*32+13+X, 1*32+12+X, 3*32+13+X
	db 1*32+17+X, 1*32+13+X, 1*32+12+X, 1*32+13+X, 3*32+15+X
	db 1*32+14+X, 1*32+15+X, 1*32+14+X, 1*32+15+X, 7*32+10+X
;	db -1, 35, 2

	;db -1, 35+35+5, 3

	db 7*32
	db -1, 2, 128

;2^x
;x=rnd(x) + 0.v
;2^0.v * 2^(rnd(x))
;
;

;zobla=2*pi/8000
zobla dd 0.000785398163397

;%define m1_length	(voice_pointer+4)	;int
;%define m1_cur		(m1_length+4)		;int
;%define m1_high	(m1_cur+4)		;int
;%define m1_pos		(m1_high+4)		;int
;cos(2*M_PI*i*freq/8000)*50+128
;freq=base_freq*2^(note/12)

;;barbarian macro, slow slow slow - barbarian code
;%macro play_note 0
;%endmacro

do_melodie:
	xor	eax, eax
	mov	al, [esi-3]
	push	eax
	push	eax
	mov	ecx, 4096
pn_0:	mov	edx, [ebp+4]
	cmp	edx, [ebp]
	jb	near pn_ok
	;a new note must be put
;	xor	eax, eax
pn_a:	mov	edx, [ebp+12]
	inc	dword [ebp+12]
	mov	al, [esi+edx]
	cmp	al, -1
	jnz	pn_1
	dec	byte [esi+edx+2]
	jnz	p_nw
	;when we are over with the loop, we put its original value (so we can have loops of loops)
	mov	al, [ebx+edx+2]
	mov	[esi+edx+2], al
	add	dword [ebp+12], 2
	;jmp	pn_a
	clc
	jnc pn_a
p_nw:	mov	al, [esi+edx+1]
	sub	[ebp+12], eax
	;jmp	pn_a
	clc
	jnc pn_a
pn_1:	push	eax
	shr	eax, 5
	inc	al
	mov	dx, 640
	mul	dx
	mov	dword [ebp], eax
	mov	dword [ebp+4], edx ;here luckily edx=0
	pop	eax
	mov	[ebp+8], edx
	and	al, 31
	jz	pn_ok
	;first : ;freq=base_freq*2^(note/12). Let's say base_freq=440
	mov	dword [esp], eax
	fild	dword [esp]
	mov	word [esp], 12
	fild	word [esp]
	fdivp	st1
	fld	st0
	frndint
	fst	st2
	fsubp	st1
	f2xm1
	fld1
	faddp	st1
	fscale
	fstp	st1
	;xor	eax, eax
	mov	ax, [esi-2]
	mov	dword [esp], eax
	fild	dword [esp]
	fmulp	st1
	;ok freq is calked, let's mul by 2*M_PI/8000
	;fld1
	;fld1
	;faddp	st1
	;fldpi
	;fmulp	st1
	;fmulp	st1
	;mov	word [esp], 8000
	;fild	word [esp]
	;fdivp	st1
	;all this code replaced by the next line
	fmul	dword [zobla]
	fstp	dword [ebp+8]
pn_ok:	fld	dword [ebp+8]
	fimul	dword [ebp+4]
	fsin
	fimul	dword [esp+4]
	fild	dword [ebp]
	fisub	dword [ebp+4]
	fidiv	dword [ebp]
	fmulp	st1
	fistp	dword [esp]
	mov	eax, [esp]
	add	[edi], al
	inc	dword [ebp+4]
	inc	edi
	dec	ecx
	jnz	near pn_0
	pop	eax
	pop	eax
	ret

sound_ok db 0

play_some_sound:
	cmp	byte [sound_ok], 0
	jnz	psso
	ret
psso:
;ret
	;get the space available (ioctl(fd, SNDCTL_DSP_GETOSPACE, &buf))
;	mov	ebx, [fd]
;	sub	esp, 16
	enter 16,0
	mov	edx, esp
	mov	ecx, 0x8010500c
	xor	eax, eax
	push	eax
	pop	ebx
	mov	bl, 4
	mov	al, 54
	int	0x80
	;ok, so in [esp] I've got the nb of fragments available for output,
	;let's fill this.
	cmp	[esp], eax
	jz	ps_end
ps_1:	;first, the voice in background
	mov	eax, [voice_pointer]
	mov	edi, sound_buf
	mov	esi, unpacked_voice
	mov	ecx, 4096
	add	esi, eax
	add	eax, ecx
	mov	[voice_pointer], ax
	push	ecx
	rep movsb
	pop	ecx
	;now, the first channel
	mov	ebp, m1
	mov	esi, fft_data+3
	mov	ebx, melodie_1
	sub	edi, ecx
	push	ecx
	call	do_melodie
	pop	ecx
	;then, the second channel
	mov	ebp, m2
	mov	esi, ifft_data+3
	mov	ebx, melodie_2
	sub	edi, ecx
	push	ecx
	call	do_melodie
	pop	edx
	mov	ecx, edi
	sub	ecx, edx
	;write fd, sound_buf, 4096
	xor	eax, eax
	push	eax
	pop	ebx
	mov	al, 4
;	mov	ebx, [fd]
	mov	bl, 4
	int	0x80

	dec	dword [esp]
	jnz	ps_1

ps_end:	add	esp, 20; 16
	ret
